Welcome to VVV

Welcome to VVV. VVV is an application that catalogs the content of removable volumes like CD and DVD disks for off-line searching. Folders and files can also be arranged in a single, virtual file system. Each folder of this virtual file system can contain files from many disks so you can arrange your data in a simple and logical way.

VVV also stores metadata information from audio files: author, title, album and so on.

VVV is available for the Windows, Linux and OS X operating systems. You can exchange catalogs between Windows, Linux and OS X computers, and you can share the same catalog, stored in a network server, among Windows, Linux and OS X computers.


Getting started

When you start VVV you will see its main window. This window contains two panes: the left pane shows the volumes and their folder structure, the right pane shows the content on the selected folder.

Create a catalog

First you need to create a catalog file: select the File/New menu or press the New button in the toolbar to create a new catalog. Catalogs have the "vvv" extension. If you have already created a catalog you can open it with the File/Open menu or with the Open toolbar button.

Catalog volumes

Now you need to catalog some disks: select the Volumes/Catalog Volume menu or press the Catalog toolbar button to open the Catalog Volume window.
Insert a disk, select or type the path of the CD/DVD drive and press the Get volume name button to see the disk name in the Volume name textbox. At the moment this button is only available in the Windows version.
You can edit the volume name: that name will be used to show the volume in the program.
Now press the Catalog button to read the disk content.
You can insert another disk and repeat these steps many times if you like, then press the Close button to return to the main window.

You will see the cataloged disks in the left pane and you will be able to browse their folders and look at the contained files. Now it's time to look at the virtual view.

Virtual view

Select the View/Virtual View menu or press the Virtual toolbar button: the left pane will change to show the virtual file system view. Now the view is empty so you need to create some folders: select the Edit/New Virtual Root Folder menu to add virtual folders. You can also right click an existing folder to show a context menu.
The folders created by the user are shown in blue, while physical folders are shown in black.

Now it's time to put something in the virtual folders. Press the Physical button to return to the physical view, then select a volume or a folder. Right-click and select the Add To Virtual Folder menu to open the Choose virtual folder window. Choose a virtual folder an press OK to add the physical folder to the virtual folder and to close the window. Return to the virtual view and look at the virtual folder: it will contain the physical folder.

You can use the Add To Virtual Folder menu with both elements from the left or right pane of the program's window, but there is a difference: you can only select a single volume or folder from the left pane, while you can select many folders or files from the right pane and assign them all to a virtual folder in a single step.

You can add the same physical folder to many virtual folders, and you can add files from different disks to the same virtual folder. Virtual folders are a powerful tool that let you rearrange your data in a logical way and group related files even if they are stored on different disks.

Searching

The program has some powerful search features. Click here for a detailed description.

These are the main VVV commands. After you have experimented with them you can look at the Edit menu that contains commands to rename and delete volumes and folders. It is also possible to add a description to files and folders.

Updating volumes

The physical volumes cataloged by VVV may change after some time. It is possible to add more sessions to a CD/DVD disk, and many people are using VVV to catalog the contents of removable hard disks.

It is possible to update an already cataloged volume: VVV will compare the volume and the information already stored in the catalog. Any new file in the volume will be added to the catalog, files deleted from the volume will be removed from the catalog. Files in the volume with a changed size or date/time will be updated in the catalog.

To update a volume select it in the left pane and select the Volumes/Update Volume menu. You can also right-click the volume and select Update from the context menu.


Getting started

Searching

You can search the catalog for files meeting your specifications. Press the Search toolbar button or select the View/Search View menu : the left pane will change to show the search tools. You can type one or more of the following: file name, file extension, description. For the file name and the description you can choose among three matching modes:

  • Check Is equal to for an exact match. The program will only return results that are equal to the typed text. Please notice that the file name also includes the extension, so you must type something like "MyDocument.pdf" if you want to match a pdf file. Typing "MyDocument" will not match the pdf file.
  • Check Starts with to match all the results that start with the text that you have typed. So if you type "game" the program will match "game", "games" and so on, but it will not match "MyGame".
  • Check Contains to match all the results that contain the text that you have typed. So if you type "game" the program will match "game", "games", "MyGame" and so on.

The searches are not case sensitive, so typing "game" will match "game", "Game" and "GAME".

In each text box you can type one or more words. If you type more than one word the text will interpreted in the following way:

  • By default words are connected with OR. So the program will match data that contain at least one of the given words.
  • A word starting with "+" is required. The program will match only data containing that word.
  • A word starting with "-" is excluded. The program will match only data that does not contain that word.
  • Many words enclosed by " are considered a single word.

Here are some examples with their meaning:

one two three
matches data containing one or more of the three words

one +two three
matching data must contain "two" and one of the other words ("one" or "three")

one -two three
matching data must contain either "one" or "three" and it must not contain "two"

"my document" text
matching data must contain either "my document" (without quotes) or "text"

+"my document" text image
matching data must contain "my document" (without quotes) and either "text" or "image"

When you have typed some text you can choose the scope of your search. You can search:

  • all the physical volumes stored in the catalog
  • only the selected physical folder, i.e. the selected folder in the physical view
  • only the selected virtual folder, i.e. the selected folder in the virtual view

Now press the Search button to start the search.


Network usage

VVV uses a relational database to store its data. This adds a lot of power to the program because it can handle large amounts of data without problems. The database is available in two versions: embedded and full server.

Each copy of VVV contains the embedded version of the database. This version does not require installation and it is invisible to the user: it is the default version and it can only open catalogs stored in the local hard disks. It cannot open catalog stored in another computer in the network, for a series of good reasons.

Often, when many computers are connected by a network, users would like to share the same catalog among all the networked computers. With VVV this is possible, but you must install a full copy of the database server in a computer. That computer will store the catalogs and it will share them with other computers: we will call it the server. Other computers will connect to the server to access catalogs.

How to install the database server

You will need to install the database server only if you want to share catalogs among many computers connected by a network. You do not need to install it if you only want to open catalogs stored in your computer.

VVV uses the Firebird database server. It is a free, open source server available for both Linux and Windows computers. You can install the server in a Windows or Linux computer and all the networked computers will be able to access the server. Windows computers can connect to a Linux server, and Linux computers can connect to a Windows server. You will need version 2.x of the server: you can download it from the Firebird home page, but below you will find direct links.

Install the server in a Windows computer

The simplest way to install the server is to use the installer: click here to download version 2.0.3. This is a link to the 2.0.3 version: you might want to look in the home page if a newer version is available.
Installation is very simple: just execute the installer and follow the instructions. If you are not an experienced user it is advisable to accept all the default settings. The installer will ask if you want to run the server as a service or as an application. The simplest way is to run it as a service. It is better to let Firebird start automatically when you start the computer so you will be able to forget about having the server installed.

In order to connect to the server from VVV you will need a username and a password: after installation a Windows server will have a SYSDBA username with the password masterkey.

Install the server in a Linux computer

There are different ways to install the server in a Linux computer. First it is better to check if a Firebird package is available for your distribution. If a package is available that is the simplest way to install the server. Be sure to install version 2. The server comes in different flavors: if you are in doubt try installing the classic server. After installation you might want to read the release notes from the link below.

If a package is not available for your distribution you can download the server from the download page of the official site. This is a link to the 2.0.3 version: you might want to look in the home page if a newer version is available. There are many Linux versions: if you are in doubt download the classic one.
You can choose between a rpm package or a .tar.gz file for distributions that do not support rpm packages. You may want to read the release notes linked at the end of the download page for information about installing the server.

In order to connect to the server from VVV you will need a username and a password: after installation a Linux server will have a SYSDBA username, but it might have different passwords, depending on the used package.
Some packages will ask for a SYSDBA password during installation, others will use a default masterkey password, others will create a file containing a random password (/opt/firebird/SYSDBA.password for the official package).

How to configure VVV

You must change some settings to make VVV connect to the server. Select the Tools/Options menu to show the Settings window, then click the Server tab.
Select the Connect to a network server checkbox and fill the Server, Username and Password text boxes. Username and Password contain, by default, "SYSDBA" and "masterkey", the default values for a Windows server and some Linux servers.
Enter the name of the server computer in the Server textbox. If the server is running in the same computer enter "localhost" (without quotes) instead of the computer name. This makes VVV a little friendlier when opening a catalog.

If you are connecting to a server, opening a catalog works in a slightly different way. When you chose the Open command a new window is displayed, asking for the path to the catalog file. Since the catalog is stored in the server, you must type the full path relative to the server, that is the path that you see when you work at the server computer.

So, if the server is a Windows computer, the path "C:\Catalogs\Catalog1.vvv" will point to the "C" disk of the server, not the "C" disk of the client. You must type a Windows path if the server is a Windows computer, even if you are connecting from a Linux computer, and vice versa.

Since usually a client cannot see the files stored in the server you must manually type the path for the first time that you use it. VVV cannot help you showing a "file open" dialog. Then you will be able to find the path in the File menu.
If you are using VVV in the server computer and you typed "localhost" in the settings window, VVV will show a browse button at the side of the catalog name to let you visually choose the catalog name. Since VVV is running in the server it can look at the stored files as usual.

Creating a new catalog works in a similar way, but you can do it only if VVV is running in the server computer. Clients usually cannot access files in the server, so they cannot create them.

Security

These instructions have explained how to connect to a server using the SYSDBA username. This is the simplest way to connect to the server, but it is important to understand that it can cause security problems.

The SYSDBA user has full access to every database stored in the server, so anybody who knows the SYSDBA password can connect to another database, non only a VVV catalog. Then he can read data and even destroy them.

This is usually not a problem if the server only stores VVV catalogs, or if it stores other database containing similar, non-sensitive information.
It can be a problem if the server also stores sensitive and important data like accounting or medical information.

It is usually not a problem in a home network where users are trusted, while it can be a problem il a large network where not all users are so trusted.

If security is a problem it is possible to create a new username and give it only the right to access VVV catalogs. People connecting with that username would not be able to access other databases.
If you already have sensitive data stored in the Firebird server you certainly have a server administrator that will be able to add and configure a new username for VVV users.


Backup and restore

You should do backup copies of your catalogs to avoid data loss in case of hardware failure or theft, for example.

The simplest way to do this is to directly copy the catalog files (*.vvv), but there is also another solution.

VVV stores data using a relational database (Firebird) so there is a way to create dedicated backup files.
You cannot use directly those backup files, but you must restore them before using them. Those backups are usually much smaller than catalog files, and a backup-and-restore cycle will usually produce a smaller catalog file.

Anyway, you can safely copy a catalog file if VVV is configured in single-user mode (the default), as long as VVV is not running.

On the other hand, if VVV is configured for network usage many users can connect to the same catalog at the same time, and you cannot be sure that nobody is using it. You should stop the database server before copying a catalog file or you could cause corruption in the catalog.
For this reason, if you are using VVV in multi-user configuration, it is recommended to make a backup instead of directly copying the catalog file. Backup is designed in such a way that other users connected to the catalog will not cause problems.
You must be working at the server computer in order to backup or restore a catalog.

Moreover, the database producers recommend using a backup to move a catalog from a computer platform to another, for example from Windows to Linux.

Use the File/Backup menu command to create a backup of the current catalog.
Use the File/Restore menu command to restore a backup to a new catalog.


Command line switches

Note: these information are for advanced users. You need them to use VVV in particular ways but are usually not needed by most users.

It is possible to pass the name of a catalog file to the command line. For example:

vvv "C:My CatalogsMy Catalog.vvv"

VVV can be invoked from the command line using switches and options that make it possible to use VVV as a portable application or to update a volume in batch mode, without user input. Option values can be specified in three ways:

  • vvv -s "option value"
  • vvv -s:"option value"
  • vvv -s"option value"

VVV as a portable application

It is possible to run VVV as a portable application, for example from an USB memory stick without installing it in the computer and without leaving any trace in the computer. The options to use the program as a portable application are the following:

-s <file name>

specifies the name of a file used to store the program's settings. Note that it is a full file name, not a path to a folder. The file name can be relative to the program's executable location or it can be absolute.
Without this option the settings would be stored in the computer, using the Registry under Windows and files under other operating systems. With this option settings are always stored in a file, and you can store that file in the USB stick.

So for example you can use one of the following command lines:

  • vvv -s "..\DataSettings\VVV Settings File.txt"
  • vvv -s:"..\DataSettings\VVV Settings File.txt"
  • vvv -s"..\DataSettings\VVV Settings File.txt"

-d <folder name>

specifies the default folder when creating a new catalog. If relative it is relative to the program's executable location. Without this option the default would be the Documents folder of the user, which has no use for a portable application.

How to batch-update a volume

These options are used to run the program from the command line instead of running it as a GUI application. They can be used to update volumes from the command line.

-v <volume name>

specifies a volume name to be processed. <volume name> is a string.

-vp <volume path>

specifies the path of the volume to be processed in the file system. If relative it is relative to the program's executable location.

-u

update the volume. This switch causes VVV to run in command line mode instead of showing a GUI.
When using this switch you always need to pass a catalog name and a volume path in the command line.
The program will not reopen the last used catalog, since it might change.

So to update a volume in batch mode you must use all the three switches above and supply a catalog name. For example:

vvv -u -v:"Ever changing volume" -vp:"D:\" "C:CatalogsMyCatalog.vvv"


Catalog volume

This window is used to catalog the content of a volume, like a CD or a DVD disk.

Insert a disk, select or type the path of the CD/DVD drive and press the Get volume name button to see the disk name in the Volume name textbox. At the moment the Get volume name button is only available in the Windows version of VVV.
You can edit the volume name: that name will be used to show the volume in the program.

Now press the Catalog button to read the disk content. The disk name will be added at the top of the list of cataloged volumes in the lower part of the window. In the Windows version the list will also contain the name read directly from the volume, in case you changed it.

You can insert another disk and repeat these steps many times if you like, then press the Close button to return to the main window.


General settings

If Reopen the last used catalog at startup is checked VVV will automatically open the last used catalog when you will start the program again. If it is not checked VVV will not open any catalog at startup.

VVV can play a beep sound at the end of a long task. If the task takes more than the number of seconds in the Beep for tasks longer than text box the program will beep. If the task takes less than that number of seconds VVV will not beep. A value of 0 seconds will cause VVV to always beep. Type a very large number to suppress beeping.

VVV might have been translated in your language. If the translation is available VVV will use it by default, so you will see it in your language.
You can press the Change language button to choose a language among the available ones. This will open a window with a languages list. The first entry is always the default language for your computer.
Note that under Linux you can select a language only if its support has been installed in the operating system.


Audio files settings

If the Catalog audio metadata checkbox is selected VVV will extract information like title, author and so on from audio metadata files, and it will store them in the catalog.
If it is not selected it will not extract those information.

The rest of the window contains many checkboxes relative to the tags contained in audio files.

If a checkbox is selected you will see the corresponding information in VVV, if it is not checked you will not see that information.


Server settings

This window contains the server connection settings, needed to connect to a catalog stored in another computer. Click here for more information.

If Connect to a network server is not checked you will only be able to open catalogs stored in this computer. You will not be able to access catalogs through the network. This is the default setting.

If Connect to a network server is checked VVV will connect to a database server to access catalogs. You must enter information about the server connection.

  • Server is the name or the IP address of the server computer. Type "localhost" (without quotes) if the server is running in this computer. You could also type the computer's name, but VVV uses the localhost name to know that it is running in the server so that it can be a little more user-friendly when opening or creating a catalog.
  • Username is used to connect to the server. The default value is "SYSDBA" (without quotes).
  • Password is used to connect to the server. The default value for Windows installations (and some Linux ones) is "masterkey" (without quotes).

You can click the Test server connection button to check if the server name is correct. This button will only use the server name, it will not test username and password.


Export data

Use this window to export your data to a CSV file. CSV files can be easily read by database and spreadsheet programs.

You can choose the character that will be used to separate the various information that will be written to the file, for example between name and size. The separator can be a comma(,), a TAB or a pipe(|) character.

If the Include headers checkbox is selected the first line of the file will contain the names of each field.

You can export:

  • All the physical volumes stored in the catalog;
  • Only the currently selected physical volume or folder and all its subfolders;
  • Only the currently selected virtual folder.

Data will be exported as Unicode, using the UTF8 encoding.


Restore catalog

Use this window to restore a catalog from an existing backup file.

You must enter the path of the backup file and the path of the catalog to be created. You will not be able to type the name of an existing file as the catalog name: you must type the name of a non-existing file.

Press OK to create the new catalog: this task might take some time, and the program will tell you when it will be finished. The program will not open the restored catalog: you will have to do it by yourself.

See also Backup and restore.


Update volume

This window is used to update the content of a volume that has been already cataloged.

The program will compare the volume and the information already stored in the catalog. Any new file in the volume will be added to the catalog, files deleted from the volume will be removed from the catalog. Files in the volume with a changed size or date/time will be updated in the catalog.

Insert a disk, select or type the path of the CD/DVD drive and press the Update button to update the catalog data with the disk content.

At the end of the volume scan VVV will show you a report of the update activity: number of files added, removed and so on. Press the Yes button to accept the changes, press the No button to discard them without modifying the catalog.

CAUTION: be careful to choose the right volume in the catalog. Selecting a volume in VVV and updating it with another physical volume will make you lose the cataloged data of the original volume. The report showed at the end of the update is useful to catch this kind of problem: if you see a very high number of new and deleted files you can answer No and check that you have selected the right volume in the catalog.